<template>
  <q-page>
    <div class="col-xs-12 col-sm-6 col-md-6 col-lg-6 q-pa-md q-pr-md">
      <q-input
        color="indigo"
        v-model="search"
        label="Ingresa Datos de Busqueda"
        placeholder="Natural"
        @input="exampleRequest"
        hint="Ingresa Datos de Busqueda"
        outlined
      >
      </q-input>
    </div>
    <div
      class="col-xs-12 col-sm-6 col-md-6 col-lg-6 q-pa-md q-pr-md row justify-center"
    >
      <q-btn push color="indigo" label="Guardar" @click="save" glossy />
    </div>
    <div class="row">
      <q-item
        v-for="(image, index) in list_img"
        :key="image.id"
        :active="active_img.includes(index)"
        clickable
        v-ripple
        @click="selectImg({ id: image.id, url: image.urls.small }, index)"
        active-class="my-menu-link"
      >
        <q-img
          :src="image.urls.small"
          spinner-color="white"
          style="height: 120px; width: 120px"
          native-context-menu
        >
          <q-icon
            class="absolute all-pointer-events"
            size="25px"
            name="cancel"
            color="white"
            @click="list_img.splice(index, 1)"
            style="top: 8px; right: 8px"
          />
          <q-icon
            v-if="active_img.includes(index)"
            class="absolute all-pointer-events"
            size="25px"
            name="done"
            color="white"
            style="top: 8px; left: 8px"
          />
        </q-img>
      </q-item>
    </div>
  </q-page>
</template>

<script>
import { mapMutations } from 'vuex'

export default {
  name: 'PageIndex',
  data () {
    return {
      active_img: [],
      search: '',
      page: 1,
      list_img: [],
      selectIMG: []
    }
  },
  methods: {
    ...mapMutations('generals', ['saveAll']),
    selectImg (current, index) {
      this.active_img.includes(index)
        ? this.active_img.splice(
          this.active_img.findIndex(ele => ele === index),
          1
        )
        : this.active_img.push(index)
      var findImg = this.selectIMG.findIndex(img => {
        return img.id === current.id
      })
      console.log(findImg)
      if (findImg > -1) {
        this.selectIMG.splice(findImg, 1)
      } else {
        this.selectIMG.push(current)
      }
      console.log(this.active_img)
    },
    async exampleRequest () {
      await this.$api
        .get('https://api.unsplash.com/search/photos?query=' + this.search, {
          params: {
            page: this.page++,
            per_page: 50,
            client_id: 'spM3SL4knutV1UnTb4pvjOomoa8crIxi4g62WVon79M'
          }
        })
        .then(res => {
          this.list_img = res.results
          console.log(this.list_img)
        })
        .catch(error => {
          console.log(error)
        })
    },
    save () {
      this.saveAll(this.selectIMG)
      this.$router.push('list')
    }
  }
}
</script>
<style lang="sass">
.my-menu-link
  color: white
  background: #F2C037
</style>
